static char *recvmsg_id=
	"@(#)Copyright (c) KOUNO Takashi -- recvmsg -- ( IPmsg recver soft ) Ver 0.4 Pre2";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>
#include <netdb.h>
#include <signal.h>
#include <pwd.h>
#include <errno.h>
#include <time.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define MAILMSG_VERSION "0.4 Pre2"

#define IPMSG_VERSION		0x001
#define IPMSG_PORT			0x979
/* #define IPMSG_PORT 2000 */
#define IPMSG_REVERSEICON	0x100

/*  command  */
#define IPMSG_NOOPERATION 0x00000000UL

#define IPMSG_BR_ENTRY 0x00000001UL
#define IPMSG_BR_EXIT 0x00000002UL
#define IPMSG_ANSENTRY 0x00000003UL
#define IPMSG_BR_ABSENCE 0x00000004UL

#define IPMSG_BR_ISGETLIST 0x00000010UL
#define IPMSG_OKGETLIST 0x00000011UL
#define IPMSG_GETLIST 0x00000012UL
#define IPMSG_ANSLIST 0x00000013UL
#define IPMSG_BR_ISGETLIST2 0x00000018UL

#define IPMSG_SENDMSG 0x00000020UL
#define IPMSG_RECVMSG 0x00000021UL
#define IPMSG_READMSG 0x00000030UL
#define IPMSG_DELMSG 0x00000031UL

#define IPMSG_GETINFO 0x00000040UL
#define IPMSG_SENDINFO 0x00000041UL

#define IPMSG_GETABSENCEINFO 0x00000050UL
#define IPMSG_SENDABSENCEINFO 0x00000051UL

/*  option for all command  */
#define IPMSG_ABSENCEOPT 0x00000100UL
#define IPMSG_SERVEROPT 0x00000200UL
#define IPMSG_DIALUPOPT 0x00010000UL

/*  option for send command  */
#define IPMSG_SENDCHECKOPT 0x00000100UL
#define IPMSG_SECRETOPT 0x00000200UL
#define IPMSG_BROADCASTOPT 0x00000400UL
#define IPMSG_MULTICASTOPT 0x00000800UL
#define IPMSG_NOPOPUPOPT 0x00001000UL
#define IPMSG_AUTORETOPT 0x00002000UL
#define IPMSG_RETRYOPT 0x00004000UL
#define IPMSG_PASSWORDOPT 0x00008000UL
#define IPMSG_NOLOGOPT 0x00020000UL
#define IPMSG_NEWMUTIOPT 0x00040000UL
#define IPMSG_NOADDLISTOPT 0x00080000UL

#define HOSTLIST_DELIMIT "\a"
#define HOSTLIST_DUMMY "\b"

/*  end of IP Messenger Communication Protocol version 1.0 define  */


#define UDP_BUF 8192
#define MAXBUFLEN 0x2ff
/* #define BROADCAST "255.255.255.255" */
#define BROADCAST "DEFAULT"
#define RECVMSGBC "/.recvmsgbc"
#define ENV_HOME "HOME"
#define MAXBCNUM 0x100
#define MAXBCLEN 16
#define MAXSTPACKET 100
#define MAX_RETRY 10
#define RETRY_WAIT 2

#define GET_MODE(command)	(command & 0x000000ff)
#define GET_OPT(command)	(command & 0x0000ff00)

typedef struct {
    int   format_ver;
    int   packet_no;
    char  msg_user[MAXBUFLEN];
    char  msg_host[MAXBUFLEN];
    int   command;
    char* group;
    char* extend;
} MSG;

int sender(int sd, char *buf, long addr, int command);
int recver(int sd);
long hosttoaddr(char *target);
int decom_msg(MSG *msg, char *buf);
/* void interrupt_exit(int sig, int code, struct sigcontext *scp, char *addr);*/
void interrupt_exit();
void print_usage(void);
int print_message(int sd, MSG *msg, struct sockaddr_in* psaddr);

int g_sd;
int g_ipmsg_port = IPMSG_PORT;
int g_broadcast_num = 0;
char g_broadcast[MAXBCNUM][MAXBCLEN];
int g_get_packet_num = 0;
int g_storage_packet[MAXSTPACKET];
int g_nflag = 1;
int g_timer_exit = 0;
char g_save_file_master[PATH_MAX] = "";
char g_save_file_number[PATH_MAX] = "";
int g_exit = 0;
char g_name[MAXBCNUM] = "";
char g_group[MAXBCNUM] = "";

int main(int argc, char *argv[])
{
	int	sd;
	char buf[UDP_BUF];
	struct hostent	*host;
	long addr;
    char* ptr;
    int lp;
    FILE* fp;
    char bcfile[PATH_MAX];
    int flag=1;
    char* p;
    int ret = 0;

    memset(g_storage_packet, 0, MAXSTPACKET);

	/* ̉ - nCt1ɂ1̃o[W*/
	for( ;argc > 1 && argv[1][0] == '-';argv++,argc-- ){
		switch( argv[1][1] ){
			case '?':
			case 'h':
                print_usage();
				exit(0);
			case 'p':
			case 'P':
				g_ipmsg_port=strtol(&argv[1][2], &ptr, 0);
				fprintf(stderr, "PORT %d(%s)\n", g_ipmsg_port, &argv[1][0]);
				if (g_ipmsg_port==0)
				  g_ipmsg_port=IPMSG_PORT;
				break;
			case 'n':
			case 'N':
				g_nflag = 0;
				break;
			case 'e':
			case 'E':
				g_timer_exit = strtol(&argv[1][2], &ptr, 0);
				fprintf(stderr, "TIMER EXIT %d(%s)\n", g_timer_exit, &argv[1][0]);
				break;
            case 'f':
            case 'F':
                strcpy(g_save_file_master, &argv[1][2]);
                break;
			default:
				break;
            }
    }

    if (argc>1){
        ptr = argv[1];
    } else {
        strcpy(bcfile, getenv(ENV_HOME));
        strcat(bcfile, RECVMSGBC);
        ptr = bcfile;
    }
    
    if (fp = fopen(ptr, "r")){
        for (g_broadcast_num=0; 
             fgets(g_broadcast[g_broadcast_num], MAXBCLEN, fp) && g_broadcast_num < MAXBCNUM;
             g_broadcast_num++){
            for (p = g_broadcast[g_broadcast_num]; *p; p++){
                if (*p == '\n' || *p == '\r'){
                    *p = '\0';
                    break;
                }
            }
            if (g_broadcast[g_broadcast_num][0] == '#'){
                g_broadcast_num--;
                continue;
            } else if (g_broadcast[g_broadcast_num][0] == '!' ||
                       g_broadcast[g_broadcast_num][0] == 'N'){
                for (p=&g_broadcast[g_broadcast_num][1]; *p;p++){
                    if (*p != '\t' && *p != ' '){
                        strcpy(g_name, p);
                        break;
                    }
                }
                g_broadcast_num--;
                continue;
            } else if (g_broadcast[g_broadcast_num][0] == '%' ||
                       g_broadcast[g_broadcast_num][0] == 'G'){
                for (p=&g_broadcast[g_broadcast_num][1]; *p;p++){
                    if (*p != '\t' && *p != ' '){
                        strcpy(g_group, p);
                        break;
                    }
                }
                g_broadcast_num--;
                continue;
            }
            g_broadcast[g_broadcast_num][MAXBCLEN-1] = '\0';
        }
        fclose(fp);
    } else {
        fprintf(stderr, "Can't open %s file : ", ptr);
        perror(NULL);
        g_broadcast_num = 1;
        strcpy(g_broadcast[0], BROADCAST);
    }

	if (!g_name[0]){
        strcpy(g_name, getpwuid(getuid())->pw_name);
    }


	if ((sd = socket(AF_INET, SOCK_DGRAM, 0)) ==-1){
		perror("Can't create socket\n");
	}
	
    if (setsockopt(sd, SOL_SOCKET, SO_BROADCAST, (char*)&flag, sizeof(int)) == -1) {
        perror("setsockopt fail");
    }

    /* Ctl-C */
    g_sd = sd;
    signal(SIGINT, interrupt_exit);
    /* Timer */
    if (g_timer_exit){
        struct itimerval value;
        signal(SIGALRM, interrupt_exit);

        value.it_interval.tv_sec = g_timer_exit;
        value.it_interval.tv_usec = 0;
        value.it_value.tv_sec = g_timer_exit;
        value.it_value.tv_usec = 0;
        setitimer(ITIMER_REAL, &value, NULL);
    }

	/* M҂ */
	if (!recver(sd)){
		ret = 1;
	}

    for (lp=0; lp<g_broadcast_num; lp++){
        sender(sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
        sender(sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
        sender(sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
    }
	close( sd );
	return ret;
}

/* Sender */
int sender( int sd, char *buf, long addr, int command )
{
	char msg[UDP_BUF];
    char hostname[MAXBUFLEN];
	static int packet_no;
	struct sockaddr_in	saddr;
	struct hostent		*host;
    char* p;

	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(g_ipmsg_port);
	saddr.sin_addr.s_addr	= addr;

	if (gethostname(hostname, MAXBUFLEN) == -1){
		strcpy(hostname,"Unknow host");
	}
    if (p = strchr(hostname, '.')){
        *p = '\0';
    }

	/* Make Message */
	sprintf(msg, "%d:%d:%s:%s:%d:%s", IPMSG_VERSION, packet_no++, getpwuid(getuid())->pw_name, hostname, command, buf ? buf : "");

	/* Send */
	if (sendto(sd, msg, strlen( msg ) +1, 0, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
		perror("sendto err");
		return	0;
	}

	return 1;
}

int entry_sender( int sd, char* name, char* group, long addr, int command)
{
	char msg[UDP_BUF];
    char hostname[MAXBUFLEN];
	static int packet_no;
	struct sockaddr_in	saddr;
	struct hostent		*host;
    char* p;
    int len;

	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(g_ipmsg_port);
	saddr.sin_addr.s_addr	= addr;

	if (gethostname(hostname, MAXBUFLEN) == -1){
		strcpy(hostname,"Unknow host");
	}
    if (p = strchr(hostname, '.')){
        *p = '\0';
    }

	/* Make Message */
	sprintf(msg, "%d:%d:%s:%s:%d:%s%c%s%c", IPMSG_VERSION, packet_no++, getpwuid(getuid())->pw_name, hostname, command, name ? name : "", '\0', group ? group : "", '\0');

	/* Send */
    len = strlen(msg);
    len += strlen(msg + len + 1) + 1;
	if (sendto(sd, msg, len, 0, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
		perror("sendto err");
		return	0;
	}

	return 1;
}

/* zXg -> AhX ϊ */
long hosttoaddr(char *target)
{
	struct sockaddr_in	saddr;
    char hostname[MAXBUFLEN];
	long addr;
	struct hostent *host;

    if (strcmp(target, BROADCAST) == 0){
        return ~0;
    }

	if ((addr = inet_addr(target)) == -1){
		if ((host = (struct hostent *)gethostbyname(target)) != NULL){
			addr = *(long *)host->h_addr;
		} else {
            fprintf(stderr, "invalid hostname %s\n", target);
			perror(NULL);
			return 0;
		}
	}
	return addr;
}

/* Receive Message function */
int recver(int sd)
{
	char buf[UDP_BUF];
	char str[UDP_BUF];
	char message[UDP_BUF]="";
	struct sockaddr_in	saddr;
	MSG msg;
	int flag=1;
	int	size;
	int lp;
    fd_set rfds;
    struct timeval tv;
    int retval;

	memset(&msg, 0, sizeof(msg));
	memset(&buf, 0, sizeof(buf));
	size=sizeof(saddr);

	/* bZ[W{̗p̗̈m */
	if ( (msg.extend=malloc(UDP_BUF)) == NULL){
		perror("Message memory allocate error!\n");
		return 0;
	}
    msg.extend[0] = '\0';

	/* sockaddr_in\̂̐ݒ */
	memset((char *)&saddr, 0, size );
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(g_ipmsg_port);
	saddr.sin_addr.s_addr	= htonl(INADDR_ANY);

	/* \PbgoCh */
    for (lp=0; 1; lp++){
        if (bind(sd, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
            if (errno == EADDRINUSE && lp<MAX_RETRY){
                sleep(RETRY_WAIT);
            } else {
                fprintf(stderr, "Bind error %d port\n", g_ipmsg_port);
                perror(NULL);
                return 0;
            }
        } else {
            break;
        }
    }


	/* Gg[ʒm */
    for (lp=0; lp<g_broadcast_num; lp++){
        if (!entry_sender(sd, g_name, g_group, hosttoaddr(g_broadcast[lp]), IPMSG_BR_ENTRY)){
            return 0;
        }
    }

	while(flag){
        if (g_exit){
            flag = 1;
        }
        FD_ZERO(&rfds);
        FD_SET(sd, &rfds);
        tv.tv_sec = 1;
        tv.tv_usec = 0;
        
        retval = select(sd+1, &rfds, NULL, NULL, &tv);
        if (retval == -1){
            perror("select fail");
            flag = 0;
        } else if (!retval){
            continue;
        }
         
        /* tJn */
		if ((retval = recvfrom(sd, buf, UDP_BUF, 0, (struct sockaddr *)&saddr, &size)) == -1){
            perror("recv error");
			return 0;
		}

		if ( !decom_msg(&msg, buf) ){
			continue;
		}
		
        /* Mobt@̃[NA(e͊ msg \̂ɑ݂) */
        memset(buf, 0, retval);

		/* R}h̔ */
		switch(GET_MODE(msg.command)){
        case IPMSG_BR_ENTRY:
            if ( !entry_sender(sd, g_name, g_group, saddr.sin_addr.s_addr, IPMSG_ANSENTRY)){
                return 0;
            }
            /* ʂ蔲` */
        case IPMSG_ANSENTRY:
        	if (g_nflag){
	            fprintf(stdout, "Entry (%s@%s%s%s[%s])\n", msg.extend[0] ? msg.extend : msg.msg_user, msg.group, msg.group[0] ? "/" : "", msg.msg_host, inet_ntoa(saddr.sin_addr));
	        }
            break;
            
        case IPMSG_BR_EXIT:
        	if (g_nflag){
	            fprintf(stdout, "Exit (%s@%s[%s])\n", msg.msg_user, msg.msg_host, inet_ntoa(saddr.sin_addr));
	        }
            break;
			
        case IPMSG_RECVMSG:
            fprintf(stdout, "%s@%s 烁bZ[W̎MmF󂯎܂\n" , msg.msg_user, msg.msg_host);
            break;
			
        case IPMSG_READMSG:
            fprintf(stdout, "%s@%s 烁bZ[W̊JmF󂯂Ƃ܂\n", msg.msg_user, msg.msg_host);
            break;

        case IPMSG_SENDMSG:
            if (!print_message(sd, &msg, &saddr)){
                return 0;
            }
            break;
		}
        fflush(stdout);
	}
	return 1;
}

int decom_msg( MSG *msg, char *buf )
{
	char *str;
	
	/* Get format version */
	if ((str=strchr( buf,':')) == NULL){
		fprintf(stderr, "Can't find format version\n" );
		return 0;
	}
	str[0]='\0';
	if ((msg->format_ver=atoi(buf)) != IPMSG_VERSION){
		return 0;
	}
	buf=str+1;
	
	/* Get Packet No */
	if ((str=strchr(buf, ':')) == NULL){
		fprintf(stderr, "Can't find Packet\n");
		return 0;
	}
	str[0]='\0';
	msg->packet_no=atoi( buf ) ;
	buf=str+1;
	
	/* Get Sender Name */
	if ((str=strchr(buf, ':')) == NULL){
		fprintf(stderr, "Can't find Sender Name\n" );
		return 0;
	}
	str[0]='\0';
	strcpy( msg->msg_user, buf );
	buf=str+1;
	
	/* Get Sendhost Name */
	if ((str=strchr(buf,':')) == NULL){
		fprintf(stderr, "Can't find Sendhost Name\n" );
		return 0;
	}
	str[0]='\0';
	strcpy( msg->msg_host, buf );
	buf=str+1;
	
	/* Get command */
	if ((str=strchr(buf,':')) == NULL){
		fprintf(stderr, "Can't find command\n" );
		return 0;
	}
	str[0]='\0';
	msg->command=atoi(buf) ;
	buf=str+1;
	
	/* Get Extension */
	sprintf(msg->extend, "%s%c%s", buf, '\0', buf + strlen(buf)+1);
    msg->group = msg->extend + strlen(msg->extend)+1;
	
	return 1;
}

/* void interrupt_exit(int sig, int code, struct sigcontext *scp, char *addr)*/
void interrupt_exit()
{
    int lp, lp2;
    signal(SIGINT, SIG_IGN);

    for (lp=0; lp<g_broadcast_num; lp++){
        sender(g_sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
        sender(g_sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
        sender(g_sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
    }
    g_exit = 1;
    signal(SIGINT, SIG_DFL);
}

void print_usage()
{
    printf("resvmsg ver %s - IPMSG recever tool\n", MAILMSG_VERSION);
    printf("\t Usage: recvmsg -[npefh] [Broadcast file]\n\n");
    printf("\t        -n : Contain [ENTRY]and[EXIT] message.");
    printf("\t        -p : Designate port number.\n");
    printf("\t        -e : Designate exit timer.\n");
    printf("\t        -f : Designate file save.\n");
    printf("\t        -h : Print this message.\n\n");
    printf("\t Ex. recvmsg -n -p2000 -e5 -f/var/log/recvmsg ~/.recvmsgbc\n");
}

int print_message(int sd, MSG* msg, struct sockaddr_in* psaddr)
{
    time_t now_time;
	char buf[UDP_BUF];
    int lp;
    FILE* fp;
    static int count = 0;

    time( &now_time );
    count++;
    for (lp=0; lp<(g_save_file_master[0] ? 2 : 1); lp++){
        if (lp==0){
            fp = stdout;
            /* M`FbN */
            if (GET_OPT(msg->command) & IPMSG_SENDCHECKOPT){
                sprintf(buf, "%d", msg->packet_no);
                if (!sender(sd, buf, psaddr->sin_addr.s_addr, IPMSG_RECVMSG)){
                    return 0;
                }
            }
            if (GET_OPT(msg->command) & IPMSG_SECRETOPT){
                sprintf(buf, "%d", msg->packet_no);
                if (!sender(sd, buf, psaddr->sin_addr.s_addr, IPMSG_READMSG)){
                    return 0;
                }
            }
            
        } else {
            sprintf(g_save_file_number, "%s%03d", g_save_file_master, count);
            if ((fp = fopen(g_save_file_number, "w")) == NULL){
                break;;
            }
        }

        fprintf(fp, "\a\a\n" );
        fprintf(fp, "----------------------------------------------\n" );

        /* u[hLXg */
        if (GET_OPT(msg->command) & IPMSG_BROADCASTOPT){
            fprintf(fp, "      Broadcast from %s ( %s )\n", 
                    msg->msg_user, msg->msg_host );
        } else {				
            /* }`LXg */
            if (GET_OPT(msg->command) & IPMSG_MULTICASTOPT){
                fprintf(fp, "      Multicast from %s ( %s )\n", 
                        msg->msg_user, msg->msg_host );
            } else {
                fprintf(fp, "      Message from %s ( %s )\n", 
                        msg->msg_user, msg->msg_host );
            }
        }
        fprintf(fp, "      at %s", ctime( &now_time )  );
        fprintf(fp, "----------------------------------------------\n" );
        fprintf(fp, "%s\n", msg->extend);
        fprintf(fp, "----------------Message End-------------------\n\n" );
        if (strncmp(msg->extend, "quit", 4) ==0){
            return 0;
        }
        
        if (fp != stdout){
            fclose(fp);
            unlink(g_save_file_master);
            symlink(g_save_file_number, g_save_file_master);
        }
    }
    return 1;
}
